<?php

namespace Drupal\eleos_example\Controller;

use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\InsertCommand;
use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\Request;

/**
 * An example ajax controller.
 */
class ExampleAjaxController extends ControllerBase {

  /**
   * The Request.
   *
   * @var \Symfony\Component\HttpFoundation\Request
   */
  protected Request $request;

  /**
   * {@inheritdoc}
   * @param ContainerInterface $container
   */
  public static function create(ContainerInterface $container): static {
    $instance = new static();
    $instance->request = $container->get('request_stack')->getCurrentRequest();

    return $instance;
  }

  /**
   * {@inheritdoc}
   */
  public function mainCallback() {
    $value = $this->request->query->get('value', 'undefined');

    $content = [
      '#markup' => $this->t('The link passed "@value"', [
        '@value' => $value,
      ]),
    ];

    $selector = '#' . $this->request->query->get('element');

    $response = new AjaxResponse();
    $response->addCommand(new InsertCommand($selector, $content));

    return $response;
  }

}
